require 'studio_game/clumsy_player'

module StudioGame
  describe 'ClumsyPlayer' do
    before do
      @player = ClumsyPlayer.new 'klutz'
    end

    it 'gets only half the point value for each treasure' do
      expect(@player.points).to eq 0

      hammer = TreasureTrove::Treasure.new :hammer, 50
      @player.found_treasure hammer
      @player.found_treasure hammer
      @player.found_treasure hammer

      expect(@player.points).to eq 75

      crowbar = TreasureTrove::Treasure.new :crowbar, 400
      @player.found_treasure crowbar
      expect(@player.points).to eq 275

      yielded = []
      @player.each_found_treasure do |treasure|
        yielded << treasure
      end

      expected = [
          TreasureTrove::Treasure.new(:hammer, 75),
          TreasureTrove::Treasure.new(:crowbar, 200)
      ]
      expect(yielded).to eq expected
    end
  end
end
